<!DOCTYPE html>
<html lang="en">
  <head>
    <title>36h</title>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0"
    />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/three.js/109/three.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/three.js/109/three.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/stats.js/r16/Stats.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/2.3.0/socket.io.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/dat-gui/0.7.6/dat.gui.js"></script>
    <link type="text/css" rel="stylesheet" href="main.css" />

    <script>
      var socket = io();

      $(document).ready(function() {
        socket.on("waveSpeed", function(data) {
          AMOUNTX = data;
          console.log("action:" + data);
        });
      });
    </script>
    <script type="x-shader/x-vertex" id="vertexshader">
      attribute float scale;
      void main() {
      	vec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );
      	gl_PointSize = scale * ( 300.0 / - mvPosition.z );
      	gl_Position = projectionMatrix * mvPosition;
      }
    </script>

    <script type="x-shader/x-fragment" id="fragmentshader">
      uniform vec3 color;
      void main() {
      	if ( length( gl_PointCoord - vec2( 0.5, 0.5 ) ) > 0.475 ) discard;
      	gl_FragColor = vec4( color, 1.0 );
      }
    </script>
    <script type="module">
      var paramDefaults = {
        radius: 4,
        segments: 32,
        waveSpeed: 0.007,
        waveHeight: 2.9999,
        waveLength: 0.021,
        positionX: 0.0,
        positionY: 0.0,
        positionZ: 0.0
      };
      var params = JSON.parse(JSON.stringify(paramDefaults));

      var stats = new Stats();
      stats.setMode(0); // 0: fps, 1: ms, 2: mb

      // align top-left
      stats.domElement.style.position = "absolute";
      stats.domElement.style.left = "0px";
      stats.domElement.style.top = "0px";

      document.body.appendChild(stats.domElement);

      var scene, camera, controls, renderer;
      var SEPARATION = 100,
        AMOUNTX = 50,
        AMOUNTY = 50;
      var container, stats;
      // var camera, scene, renderer;
      var particles,
        count = 0;
      var mouseX = 0,
        mouseY = 0;
      var windowHalfX = window.innerWidth / 2;
      var windowHalfY = window.innerHeight / 2;

      init();
      animate();

      function init() {
        scene = new THREE.Scene();
        container = document.createElement("div");
        camera = new THREE.PerspectiveCamera(
          75,
          window.innerWidth / window.innerHeight,
          1,
          10000
        );
        camera.position.x = 160;
        camera.position.y = 8;
        camera.position.z = 200;

        var numParticles = AMOUNTX * AMOUNTY;
        var positions = new Float32Array(numParticles * 3);
        var scales = new Float32Array(numParticles);
        var i = 0,
          j = 0;

        renderer = new THREE.WebGLRenderer();
        renderer.setSize(window.innerWidth, window.innerHeight);

        document.body.appendChild(container);
        // controls = new OrbitControls(camera, renderer.domElement);

        // controls.minDistance = params.radius * 1.1;
        // controls.maxDistance = params.radius * 20;

        // controls.rotateSpeed = 1.0;
        // controls.zoomSpeed = 1.2;

        // controls.enableZoom = true;

        // controls.enableDamping = true;
        // controls.dampingFactor = 0.3;

        // controls.keys = [65, 83, 68];

        for (var ix = 0; ix < AMOUNTX; ix++) {
          for (var iy = 0; iy < AMOUNTY; iy++) {
            positions[i] = ix * SEPARATION - (AMOUNTX * SEPARATION) / 2; // x
            positions[i + 1] = 0; // y
            positions[i + 2] = iy * SEPARATION - (AMOUNTY * SEPARATION) / 2; // z
            scales[j] = 1;
            i += 3;
            j++;
          }
        }
        var geometry = new THREE.BufferGeometry();
        geometry.addAttribute(
          "position",
          new THREE.BufferAttribute(positions, 3)
        );
        geometry.addAttribute("scale", new THREE.BufferAttribute(scales, 1));
        var material = new THREE.ShaderMaterial({
          uniforms: {
            color: { value: new THREE.Color(0x85ffeb) }
          },
          vertexShader: document.getElementById("vertexshader").textContent,
          fragmentShader: document.getElementById("fragmentshader").textContent
        });

        particles = new THREE.Points(geometry, material);
        scene.add(particles);

        renderer = new THREE.WebGLRenderer({
          antialias: true,
          alpha: true
          // canvas
        });
        renderer.setPixelRatio(window.devicePixelRatio);
        renderer.setSize(window.innerWidth, window.innerHeight);
        container.appendChild(renderer.domElement);
        document.addEventListener("mousemove", onDocumentMouseMove, false);
        document.addEventListener("touchstart", onDocumentTouchStart, false);
        document.addEventListener("touchmove", onDocumentTouchMove, false);
        //
        window.addEventListener("resize", onWindowResize, false);
      }
      function onWindowResize() {
        windowHalfX = window.innerWidth / 2;
        windowHalfY = window.innerHeight / 2;
        camera.aspect = window.innerWidth / window.innerHeight;
        camera.updateProjectionMatrix();
        renderer.setSize(window.innerWidth, window.innerHeight);
      }

      function onDocumentMouseMove(event) {
        mouseX = event.clientX - windowHalfX;
        mouseY = event.clientY - windowHalfY;
      }
      function onDocumentTouchStart(event) {
        if (event.touches.length === 1) {
          event.preventDefault();
          mouseX = event.touches[0].pageX - windowHalfX;
          mouseY = event.touches[0].pageY - windowHalfY;
        }
      }
      function onDocumentTouchMove(event) {
        if (event.touches.length === 1) {
          event.preventDefault();
          mouseX = event.touches[0].pageX - windowHalfX;
          mouseY = event.touches[0].pageY - windowHalfY;
        }
      }

      function animate() {
        requestAnimationFrame(animate);
        render();
      }
      function render() {
        camera.position.x += (mouseX - camera.position.x) * 0.05;
        camera.position.y += (-mouseY - camera.position.y) * 0.05;
        camera.lookAt(scene.position);
        var positions = particles.geometry.attributes.position.array;
        var scales = particles.geometry.attributes.scale.array;
        var i = 0,
          j = 0;
        for (var ix = 0; ix < AMOUNTX; ix++) {
          for (var iy = 0; iy < AMOUNTY; iy++) {
            positions[i + 1] =
              Math.sin((ix + count) * 0.3) * 50 +
              Math.sin((iy + count) * 0.5) * 50;
            scales[j] =
              (Math.sin((ix + count) * 0.3) + 1) * 8 +
              (Math.sin((iy + count) * 0.5) + 1) * 8;
            i += 3;
            j++;
          }
        }
        particles.geometry.attributes.position.needsUpdate = true;
        particles.geometry.attributes.scale.needsUpdate = true;
        renderer.render(scene, camera);
        count += 0.1;
      }
    </script>
  </head>
  <body></body>
</html>
